
// derived from https://git.dervland.net/biglyderv/new-bigly-chat/src/branch/master/docs/stats.php
function rankCalc(result, iterations = 10) {
    let matrixe = {}
    let fng = {};
    let fnc = {};
    let frs = {};
    let msum_old = 0.001;
    let pr = {};

    for (let unn in result) {
        matrixe[unn] = {};
        matrixe[unn][unn] = 1;
        frs[unn] = result[unn].followers;
        fng[unn] = result[unn].following;
        fnc[unn] = Object.keys(frs[unn]).length;
        pr[unn] = 1;
    }

    for (let unn in result) {
        let fnu = frs[unn];
        for (let follow of fnu) {
            if (follow == unn) continue;
            let dst = fnc[fnu] || 0;
            matrixe[unn][follow] = 1 + 0.1 / (dst + 10);
            msum_old += matrixe[unn][follow];
        }
        for (let unn2 in result) {
            if (!matrixe[unn][unn2]) {
                matrixe[unn][unn2] = 0;
            }
        }
    }


    for (let i = 0; i < iterations; i++) {
        let prold = pr;
        let matrixf = matrixe;

        pr = [];
        matrixe = [];
        let msum = 1;

        for (let una in result) {
            pr[una] = 0;
            matrixe[una] = [];
            if (frs[una].length == 0) {
                matrixe[una] = structuredClone(matrixf[una]); // probably not efficient
                continue;
            }

            for (let unb in result) {
                let prb = prold[unb];
                if (prb < 1 / 1e9 || fnc[unb] == 0) {
                    matrixe[una][unb] = matrixf[una][unb];
                    continue;
                }
                matrixe[una][unb] = 0.03;

                for (let unc in result) {
                    matrixe[una][unb] += matrixf[una][unc] * matrixf[unc][unb];
                }

                msum += matrixe[una][unb];
                pr[una] += prb * matrixe[una][unb];
            }
        }


        for (let una in result) {
            if ((frs[una]).length == 0) continue;

            for (let unb in result) {
                matrixe[una][unb] *= msum_old / msum;
            }
        }

        let new_sum = Object.values(pr).reduce((a, b) => a + b, 0)

        for (let unn in result) {
            pr[unn] /= new_sum;
        }
        
        console.log(`Iteration ${i} calculated`);
    }

    return pr;

}

export {
    rankCalc
}